<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../.resources/report.css" type="text/css"/><link rel="shortcut icon" href="../.resources/report.gif" type="image/gif"/><title>Board.java</title><link rel="stylesheet" href="../.resources/prettify.css" type="text/css"/><script type="text/javascript" src="../.resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../.sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">JaCoCoverage analysis of project &quot;ATL-OTHELLO-Monir&quot; (powered by JaCoCo from EclEmma)</a> &gt; <a href="index.source.html" class="el_package">esi.atl.othello.monir.model</a> &gt; <span class="el_source">Board.java</span></div><h1>Board.java</h1><pre class="source lang-java linenums">package esi.atl.othello.monir.model;

/**
 * This class represents the Board.
 *
 * @author Monir Nasser
 */
public class Board {

    private final Piece[][] pieces;
<span class="fc" id="L11">    private final int NB_ROW = 8;</span>
<span class="fc" id="L12">    private final int NB_COLUMN = 8;</span>

    /**
     * This method construct the board.
     */
<span class="fc" id="L17">    public Board() {</span>
<span class="fc" id="L18">        pieces = new Piece[NB_ROW][NB_COLUMN];</span>
<span class="fc" id="L19">    }</span>

    /**
     * This method check if the position is inside the board.
     *
     * @param position The position.
     * @return A Boolean.
     */
    public boolean isInside(Position position) {
<span class="fc bfc" id="L28" title="All 2 branches covered.">        return (pieces.length &gt; position.getRow() </span>
<span class="fc bfc" id="L29" title="All 2 branches covered.">                &amp;&amp; position.getRow() &gt;= 0) </span>
<span class="fc bfc" id="L30" title="All 2 branches covered.">                &amp;&amp; (pieces[0].length &gt; position.getColumn() </span>
<span class="fc bfc" id="L31" title="All 2 branches covered.">                &amp;&amp; position.getColumn() &gt;= 0);</span>
    }

    /**
     * This method check if the square is free or not.
     *
     * @param position The position.
     * @return A boolean
     */
    public boolean isFree(Position position) {
<span class="fc bfc" id="L41" title="All 2 branches covered.">        if (!isInside(position)) {</span>
<span class="fc" id="L42">            throw new IllegalArgumentException(&quot;the position is not inside of the board&quot;);</span>
        }
<span class="fc bfc" id="L44" title="All 2 branches covered.">        return pieces[position.getRow()][position.getColumn()] == null;</span>
    }

    /**
     * this method put a pieces in the board in a given position and check if
     * the position is inside or not and if the piece is null
     *
     * @param piece
     * @param position
     */
    public void put(Piece piece, Position position) {
<span class="fc bfc" id="L55" title="All 2 branches covered.">        if (isInside(position) == false) {</span>
<span class="fc" id="L56">            throw new IllegalArgumentException(&quot;the position is outside of the board.&quot;);</span>
        }
<span class="fc bfc" id="L58" title="All 2 branches covered.">        if (piece == null) {</span>
<span class="fc" id="L59">            throw new IllegalArgumentException(&quot;the piece is null&quot;);</span>
        }
<span class="fc bfc" id="L61" title="All 2 branches covered.">        if (!isFree(position)) {</span>
<span class="fc" id="L62">            throw new IllegalArgumentException(&quot;The position is not free&quot;);</span>
        }
<span class="fc" id="L64">        this.pieces[position.getRow()][position.getColumn()] = piece;</span>
<span class="fc" id="L65">    }</span>

    /**
     * This method allows us to get he piece at the position given in paramater.
     *
     * @param position The position we need the piece.
     * @return The piece at the position.
     */
    public Piece getPiece(Position position) {
<span class="fc" id="L74">        return pieces[position.getRow()][position.getColumn()];</span>
    }

    /**
     * This method allows us to get the tab of pieces.
     *
     * @return The tab of pieces.
     */
    public Piece[][] getPieces() {
<span class="fc" id="L83">        return pieces;</span>
    }

    /**
     * This method allows us to get the number row of board.
     *
     * @return An int.
     */
    public int getNB_ROW() {
<span class="fc" id="L92">        return NB_ROW;</span>
    }

    /**
     * This method allows us to get the number column of board.
     *
     * @return An int.
     */
    public int getNB_COLUMN() {
<span class="fc" id="L101">        return NB_COLUMN;</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.6.201602180812</span></div></body></html>